/* -*- Mode: C; c-file-style: "gnu" -*-
   array-class.h -- things dealing with the fake array clazzfiles we generate.
   Created: Chris Toshok <toshok@hungry.com>, 28-Jul-1997
 */
/*
  This file is part of Japhar, the GNU Virtual Machine for Java Bytecodes.
  Japhar is a project of The Hungry Programmers, GNU, and OryxSoft.

  Copyright (C) 1997, 1998, 1999 The Hungry Programmers

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _hungry_array_class_h
#define _hungry_array_class_h

#include "jni.h"

#ifdef __cplusplus
extern "C" {
#endif

#define ARRAY_LENGTH_INDEX	0
#define ARRAY_TYPE_INDEX	1
#define ARRAY_BODY_INDEX	2
#define ARRAY_ELSIZE_INDEX	3

  extern ClazzFile* createFakeArrayClass(JNIEnv *env, char *class_name);
  extern ClazzFile* createFakeArrayRemoveDimension(JNIEnv *env, jclass array);

#ifdef __cplusplus
};
#endif

#endif /* _hungry_array_class_h */
