/*
  This file is part of Japhar, the GNU Virtual Machine for Java Bytecodes.
  Japhar is a project of The Hungry Programmers, GNU, and OryxSoft.

  Copyright (C) 1997, 1998, 1999 The Hungry Programmers

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef INIT_H
#define INIT_H

#include "config.h"
#include "jni.h"

#ifdef __cplusplus
extern "C" {
#endif

  /* This function allows architectures which link some of their
     system level libraries to load them before any java code 
     actually executes. */
  extern int  initialize_system_libraries(void);

  extern void lowlevel_thread_init(JNIEnv *env, jboolean is_primordial,  
				   char *name, jobject threadgroup,
				   int priority);

  extern void initialize_class_class(JNIEnv *env);

#ifdef __cplusplus
};
#endif

#endif /* INIT_H */
