/* -*- Mode: C; c-file-style: "gnu" -*-
   method.h -- method lookup.
   Created: Chris Toshok <toshok@hungry.com>, 23-Aug-1998
 */
/*
  This file is part of Japhar, the GNU Virtual Machine for Java Bytecodes.
  Japhar is a project of The Hungry Programmers, GNU, and OryxSoft.

  Copyright (C) 1997, 1998, 1999 The Hungry Programmers

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

#ifndef _method_h
#define _method_h

#include "objects.h"
#include "ClazzFile.h"

#ifdef __cplusplus
extern "C" {
#endif

  extern MethodStruct *find_method(JNIEnv *env, jclass cls,
				   const char *name, const char *sig);

  extern MethodStruct *find_static_method(JNIEnv *env, jclass cls,
					  const char *name, const char *sig);

#ifdef __cplusplus
};
#endif

#endif /* _method_h */
