/* -*- Mode: C; c-file-style: "gnu" -*-
   resolve.h -- prototypes for resolving classes.
   Created: Chris Toshok <toshok@hungry.com>, 28-Jul-1997
 */
/*
  This file is part of Japhar, the GNU Virtual Machine for Java Bytecodes.
  Japhar is a project of The Hungry Programmers, GNU, and OryxSoft.

  Copyright (C) 1997, 1998, 1999 The Hungry Programmers

  This library is free software; you can redistribute it and/or
  modify it under the terms of the GNU Library General Public
  License as published by the Free Software Foundation; either
  version 2 of the License, or (at your option) any later version.

  This library is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
  Library General Public License for more details.

  You should have received a copy of the GNU Library General Public
  License along with this library; if not, write to the Free Software
  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/
#ifndef _hungry_resolve_h
#define _hungry_resolve_h

#include "ClazzFile.h"
#include "jni.h"
#include "classpath.h"

#ifdef __cplusplus
extern "C" {
#endif

  extern ClazzFile* find_class_on_classpath(JNIEnv *env, const char *dotted_class_name,
					    const char *class_name,
					    ClasspathEntry *entries, int num_entries);
  extern ClazzFile* find_class(JNIEnv *env, const char *class_name);

#ifdef __cplusplus
};
#endif

#endif /* _hungry_resolve_h */
